; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version 10/2017																
;																				
; Ein Byte aus EEPROM holen Z+1													
;																				
; INPUT:	ZL Adresse 	(low)													
;			ZH Adresse 	(High)													
;																				
; OUTPUT: 	temp1 		(DATEN)													
;																				
EEPROM_READ_Z_TEMP1:
	sbic EECR,EEWE 		; Wait for completion of previous write
	rjmp EEPROM_READ_Z_TEMP1
;-------------------------------------------------------------------------------
	out  EEARH, ZH		; ADRESSE setzen						
	out  EEARL, ZL
	sbi  EECR,EERE		; Start eeprom read by writing EERE		
	in 	 temp1,EEDR		; Read data from data register			
	adiw ZL,1			; Z-ADRESSE +1 							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version 06/2024																
;																				
; Ein Byte im EEPROM ablegen und Z+1											
;																				
; INPUT:	ZL Adresse 	(low)													
;			ZH Adresse 	(High)													
; 		 	temp1 		(DATA)													
;																				
EEPROM_WRITE_Z_TEMP1:
	WDR
	sbic EECR,EEWE		; Wait for completion of previous write
	rjmp EEPROM_WRITE_Z_TEMP1
;-------------------------------------------------------------------------------
	out  EEARH,ZH		; ADRESSE setzen						
	out  EEARL,ZL
	out  EEDR, temp1	; Write data  to data register			
	sbi  EECR, EEMWE	; Write logical one to EEMWE			
	sbi  EECR, EEWE		; Start eeprom write by setting EEWE	
	adiw ZL,1			; Z-ADRESSE +1 							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################


