; ##############################################################################
; ##############################################################################
; ##############################################################################
; 60 x 24h + Minuten = 1440 Bytes pro Tag										
; aus hh und mm																	
TWI_BERECHNUNG_EEPROM_ZEIGER_hh_mm:
	; Stunde x 60			
	LDS temp1,(adr_hh)
	ldi temp2,60
	mul temp1,temp2					; Ergebnis in R0 R1	
	mov temp1,R0
	mov temp2,R1
	; Minute addieren		
	LDS temp,(adr_mm)
	add temp1,temp
	adc temp2,NULL
	STS(adr_EEPROM_ZEIGER_L),temp1	; Zeiger save		
	STS(adr_EEPROM_ZEIGER_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Mo=Offset=   0																
; Di=Offset= 2.000																
; Mi=Offset= 4.000																
; Do=Offset= 6.000																
; Fr=Offset= 8.000																
; Sa=Offset=10.000																
; SO=Offset=12.000																
; fr EEPROM ablegen der Daten													
; aus Wochentag																	
TWI_BERECHNUNG_EEPROM_TAG_OFFSET:
	clr temp1
	clr temp2
	ldi temp3,low (2000)
	ldi temp4,high(2000)
	LDS temp9,(adr_WOCHENTAG)				; Tag load Mo=1 
;-------------------------------------------------------------------------------
TWI_BERECHNUNG_OFFSET_EEPROM_s:
	add temp1,temp3
	adc temp2,temp4
	dec temp9								; -1			
	brne TWI_BERECHNUNG_OFFSET_EEPROM_s
;-------------------------------------------------------------------------------
	sub temp1,temp3							; 1xsubtrahieren
	sbc temp2,temp4
	STS(adr_OFFSET_TAG_L),temp1				; save			
	STS(adr_OFFSET_TAG_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Mo=Offset=   0																
; Di=Offset= 2.000																
; Mi=Offset= 4.000																
; Do=Offset= 6.000																
; Fr=Offset= 8.000																
; Sa=Offset=10.000																
; SO=Offset=12.000																
; fr EEPROM anzeigen der Diagramm-Daten										
; aus DIAGRAMM-TAG																
TWI_BERECHNUNG_OFFSET_DIAGRAMM_TAG:
	clr temp1
	clr temp2
	LDS temp9,(adr_DIAGRAMM_TAG)	
;-------------------------------------------------------------------------------
TWI_BERECHNUNG_OFFSET_DIAGRAMM_s:
	ldi temp3,low (2000)
	ldi temp4,high(2000)
	add temp1,temp3
	adc temp2,temp4
	dec temp9								; Schleife-1	
	brne TWI_BERECHNUNG_OFFSET_DIAGRAMM_s
;-------------------------------------------------------------------------------
	sub temp1,temp3							; 1xsubtrahieren
	sbc temp2,temp4
	STS(adr_OFFSET_DIAGRAMM_L),temp1		; save	
	STS(adr_OFFSET_DIAGRAMM_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Z+1																			
TWI_EEPROM_READ_Z_TEMP1:
	ldi temp1,(TWI_ADR_EEPROM)	; adress	
	rcall TWI_MT_START_TEMP1	; MT-Start	
	mov temp1,ZL
	rcall TWI_MT_DATA_TEMP1
	mov temp1,ZH
	rcall TWI_MT_DATA_TEMP1
	adiw ZL,1					; Z+1		
	ldi temp1,(TWI_ADR_EEPROM)	; adress	
	rcall TWI_MR_START_TEMP1	; MR-Start	
	rjmp TWI_MR_LAST_DATA_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Z+1																			
; mit berprfung																
TWI_EEPROM_WRITE_Z_TEMP1:
	push temp1						; Data sichern			
	push temp1						; Data sichern			
	ldi temp1,(TWI_ADR_EEPROM)		; adress				
	rcall TWI_MT_START_TEMP1		; MT-Start				
	mov temp1,ZL				
	rcall TWI_MT_DATA_TEMP1
	mov temp1,ZH
	rcall TWI_MT_DATA_TEMP1
	pop temp1						; Data wiederherstellen	
	rcall TWI_MT_DATA_TEMP1
	adiw ZL,1						; Z+1					
	rcall TWI_STOP
	rcall WAIT_1ms					; 1ms Pause !			
;-------------------------------------------------------------------------------
	sbiw ZL,1						; Z-1					
	pop temp2						; Data wiederherstellen, jezt temp2
	rcall TWI_EEPROM_READ_Z_TEMP1
	cp temp1,temp2
	brne TWI_EEPROM_WRITE_ERROR
	ret
;-------------------------------------------------------------------------------
TWI_EEPROM_WRITE_ERROR:
	ROT_ON
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 60 Werte pro h x 24h = 1.440 Bytes pro Tag									
TWI_EEPROM_SAVE_DATENFELD:
	rcall ZEILE_0_CLEAR					; Zeile clear					
	rcall TWI_BERECHNUNG_EEPROM_ZEIGER_hh_mm; aus hh und mm				
; Anzeige Statuszeile															
	ldi temp1,15
	ldi temp2,0
	rcall KURSOR_POSITION_TEMP1_2		; temp1=Spalte temp2=Zeile		
	rcall FARBE_GRAU
	rcall TEXT_EEPROM
	ldi ZL,low (adr_TWI_EEP_DATA_U_MO)	; Z auf "U"						
	ldi ZH,high(adr_TWI_EEP_DATA_U_MO)
	LDS temp1,(adr_EEPROM_ZEIGER_L)		; Zeiger load					
	LDS temp2,(adr_EEPROM_ZEIGER_H)
	add ZL,temp1						; addieren						
	adc ZH,temp2	
	LDS temp1,(adr_OFFSET_TAG_L)		; Tag-Offset					
	LDS temp2,(adr_OFFSET_TAG_H)
	add ZL,temp1						; addieren						
	adc ZH,temp2
	mov temp1,ZL						; Kopie							
	mov temp2,ZH
	rcall ZAHL_TEMP1_2
	LDS temp1,(adr_U)
	rcall ANZEIGE_U_TEMP1
	LDS temp1,(adr_P)
	rcall ANZEIGE_P_TEMP1
	rcall TFT_PAKET_SENDEN
; U save																		
	ldi ZL,low (adr_TWI_EEP_DATA_U_MO)	; Z auf "U"						
	ldi ZH,high(adr_TWI_EEP_DATA_U_MO)
	LDS temp1,(adr_EEPROM_ZEIGER_L)		; Zeiger load					
	LDS temp2,(adr_EEPROM_ZEIGER_H)
	add ZL,temp1						; addieren						
	adc ZH,temp2	
	LDS temp1,(adr_OFFSET_TAG_L)		; Tag-Offset					
	LDS temp2,(adr_OFFSET_TAG_H)
	add ZL,temp1						; addieren						
	adc ZH,temp2	
	LDS temp1,(adr_U)
	rcall TWI_EEPROM_WRITE_Z_TEMP1		; write							
	rcall TWI_EEPROM_SAVE_DUMMY			; Dummy							
; i save																		
	ldi ZL,low (adr_TWI_EEP_DATA_i_MO)	; Z auf "i"						
	ldi ZH,high(adr_TWI_EEP_DATA_i_MO)
	LDS temp1,(adr_EEPROM_ZEIGER_L)		; Zeiger load					
	LDS temp2,(adr_EEPROM_ZEIGER_H)
	add ZL,temp1						; addieren						
	adc ZH,temp2	
	LDS temp1,(adr_OFFSET_TAG_L)		; Tag-Offset					
	LDS temp2,(adr_OFFSET_TAG_H)
	add ZL,temp1						; addieren						
	adc ZH,temp2	
	LDS temp1,(adr_i)
	rcall TWI_EEPROM_WRITE_Z_TEMP1		; write							
	rcall TWI_EEPROM_SAVE_DUMMY			; Dummy							
; P save																		
	ldi ZL,low (adr_TWI_EEP_DATA_P_MO)	;  Z auf "P"					
	ldi ZH,high(adr_TWI_EEP_DATA_P_MO)
	LDS temp1,(adr_EEPROM_ZEIGER_L)		; Zeiger load					
	LDS temp2,(adr_EEPROM_ZEIGER_H)
	add ZL,temp1						; addieren						
	adc ZH,temp2	
	LDS temp1,(adr_OFFSET_TAG_L)		; Tag-Offset					
	LDS temp2,(adr_OFFSET_TAG_H)
	add ZL,temp1						; addieren						
	adc ZH,temp2	
	LDS temp1,(adr_P)
	rcall TWI_EEPROM_WRITE_Z_TEMP1		; write							
	rjmp TWI_EEPROM_SAVE_DUMMY			; Dummy							
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 60=1h																			
TWI_EEPROM_SAVE_DUMMY:
	ldi temp9,60					; 60=1h 						
;-------------------------------------------------------------------------------
TWI_EEPROM_SAVE_DUMMY10_s:
	ldi temp1,0
	rcall TWI_EEPROM_WRITE_Z_TEMP1	; write							
	dec temp9
	brne TWI_EEPROM_SAVE_DUMMY10_s
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TWI_EEPROM_SAVE_P_MAX:
	ldi ZL,low (adr_TWI_EEP_P_MAX)
	ldi ZH,high(adr_TWI_EEP_P_MAX)
	LDS temp1,(adr_P_MAX)
	rjmp TWI_EEPROM_WRITE_Z_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
TWI_EEPROM_READ_P_MAX:
	ldi ZL,low (adr_TWI_EEP_P_MAX)
	ldi ZH,high(adr_TWI_EEP_P_MAX)
	rcall TWI_EEPROM_READ_Z_TEMP1
	STS(adr_P_MAX),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Wattstunden pro TAG															
TWI_EEPROM_SAVE_DATENFELD_Wh:
	ldi ZL,low (adr_TWI_EEP_DATA_JAHR)
	ldi ZH,high(adr_TWI_EEP_DATA_JAHR)
	LDS temp1,(adr_MONAT)			; Monat			
	dec temp1						; -1			
	ldi temp2,31					; 31			
	mul temp1,temp2					; Monat x 31	
	mov ZL,R0						; Kopie			
	mov ZH,R1
	LDS temp,(adr_TAG)				; Tag			
	add ZL,temp						; addieren		
	adc ZH,NULL
	LSL ZL							; x2			
	ROL ZH
	LDS temp1,(adr_Wh_H)
	rcall TWI_EEPROM_WRITE_Z_TEMP1	; save			
	LDS temp1,(adr_Wh_L)
	rjmp  TWI_EEPROM_WRITE_Z_TEMP1	; save			
; ##############################################################################
; ##############################################################################
; ##############################################################################
TWI_EEPROM_TAG_CLEAR:
	rcall TFT_CLEAR
	rcall FARBE_GRUEN
	rcall TEXT_EEPROM
	rcall TFT_PAKET_SENDEN
	rcall TWI_BERECHNUNG_EEPROM_TAG_OFFSET
; U clear																		
	rcall ASCII_U
	rcall TFT_PAKET_SENDEN
	ldi ZL,low (adr_TWI_EEP_DATA_U_MO)	; Z auf "U"						
	ldi ZH,high(adr_TWI_EEP_DATA_U_MO)
	LDS temp1,(adr_OFFSET_TAG_L)		; Tag-Offset					
	LDS temp2,(adr_OFFSET_TAG_H)
	add ZL,temp1						; addieren						
	adc ZH,temp2	
	rcall TWI_EEPROM_TAG_CLEAR_BEREICH
; i clear																		
	rcall ASCII_i_
	rcall TFT_PAKET_SENDEN
	ldi ZL,low (adr_TWI_EEP_DATA_i_MO)	; Z auf "i"						
	ldi ZH,high(adr_TWI_EEP_DATA_i_MO)
	LDS temp1,(adr_OFFSET_TAG_L)		; Tag-Offset					
	LDS temp2,(adr_OFFSET_TAG_H)
	add ZL,temp1						; addieren						
	adc ZH,temp2	
	rcall TWI_EEPROM_TAG_CLEAR_BEREICH
; P clear																		
	rcall ASCII_P
	rcall TFT_PAKET_SENDEN
	ldi ZL,low (adr_TWI_EEP_DATA_P_MO)	; Z auf "P"						
	ldi ZH,high(adr_TWI_EEP_DATA_P_MO)
	LDS temp1,(adr_OFFSET_TAG_L)		; Tag-Offset					
	LDS temp2,(adr_OFFSET_TAG_H)
	add ZL,temp1						; addieren						
	adc ZH,temp2	
	rcall TWI_EEPROM_TAG_CLEAR_BEREICH
	rcall TFT_CLEAR
	ret
;-------------------------------------------------------------------------------
TWI_EEPROM_TAG_CLEAR_BEREICH:	
	ldi YL,low (1500)					; Schleife						
	ldi YH,high(1500)
TWI_EEPROM_TAG_CLEAR_s:	
	ldi temp1,0						; Wert	
	rcall TWI_EEPROM_WRITE_Z_TEMP1	; wrte	
	sbiw YL,1						; Y-1	
;-------------------------------------------------------------------------------
	tst YL
	brne TWI_EEPROM_TAG_CLEAR_w
	rcall ASCII_PUNKT
	rcall TFT_PAKET_SENDEN
TWI_EEPROM_TAG_CLEAR_w:	
;-------------------------------------------------------------------------------
	tst YL
	brne TWI_EEPROM_TAG_CLEAR_s
	tst YH
	brne TWI_EEPROM_TAG_CLEAR_s
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################


















