; #############################################################################
; #############################################################################
; #############################################################################
TFT_INI:
	rcall TFT_CLEAR
	rcall TFT_CURSOR_OFF

	ldi temp1,(TWI_ADR_TFT)
	rcall TWI_MT_START_TEMP1
	brcc TFT_INI_ERROR
	ret
;-------------------------------------------------------------------------------
TFT_INI_ERROR:
	ROT_ON
	rcall BEEP
TFT_INI_ERROR_s:
	rjmp TFT_INI_ERROR_s
; #############################################################################
; #############################################################################
; #############################################################################
TFT_CLEAR:
	ldi temp,12								; Clear
	rcall TFT_DATA_TEMP
	rjmp TFT_PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
TFT_CURSOR_OFF:
	rcall ASCII_ESC_27	; ESC 		
	rcall ASCII_T
	rcall ASCII_C
	rcall ASCII_NULL	; NULL		
	rjmp TFT_PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
TFT_INFO:
	rcall TFT_CLEAR
	rcall FARBE_GRUEN
	rcall ASCII_ESC_27	; ESC 		
	rcall ASCII_T
	rcall ASCII_I
	rjmp TFT_PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
; Puffer mit DATENBYTES laden, wird per "TFT_PAKET_SENDEN" zum Display gesendet	
;																				
;	inp: temp																	
;																				
TFT_DATA_TEMP:
	; Sicherungskopie	
	push ZL
	push ZH
	push temp
	push temp1
	; Z-ZEIGER			
	ldi ZL,LOW (adr_GRAFIC_PUFFER_256)
	ldi ZH,HIGH(adr_GRAFIC_PUFFER_256)
	; addieren			
	LDS temp1,(adr_TFT_ZEIGER)
	add ZL,temp1
	adc ZH,NULL
	; speichern nach Z	
	ST Z,temp
	inc temp1
	; Zeiger speichern	
	STS(adr_TFT_ZEIGER),temp1
	; Puffer zu voll ?	
	cpi temp1,255
	brne TFT_DATA_FERTIG
	; sofort leeren		
	rcall TFT_PAKET_SENDEN
;-------------------------------------------------------------------------------
TFT_DATA_FERTIG:
	; wiederherstellen (sicherungskopie)
	pop temp1
	pop temp
	pop ZH
	pop ZL
ret
; #############################################################################
; #############################################################################
; #############################################################################
; komplettes Paket zum Display senden 											
;																				
; <DC1> <LEN> <DATA> <PS>														
;																				
; temp = Hilfsregister															
; temp1= Hilfsregister															
; temp8= Zeiger																	
; temp9= Prfsumme (PS)															
; ZL   = ZEIGER																	
; ZH   = ZEIGER																	
TFT_PAKET_SENDEN:
	; Daten vorhanden ? len = NULL ?
	LDS temp,(adr_TFT_ZEIGER)
	tst temp								; Null ?	
	brne TFT_PAKET_SENDEN_RUN				; nein		
	ret
;-----------------------------------------------------------------------------
TFT_PAKET_SENDEN_RUN:
	push temp			; Hilfsregister	
	push temp1			; Hilfsregister	
;	push temp2
;	push temp3
;	push temp4
;	push temp5
;	push temp6
;	push temp7
	push temp8			; Hilfsregister	
	push temp9			; Hilfsregister	
	push ZL
	push ZH
;-----------------------------------------------------------------------------
TFT_PAKET_SENDEN_S:
	; TWI START				
	ldi temp1,(TWI_ADR_TFT)
	rcall TWI_MT_START_TEMP1
	WDR
	; <DC1>				
	ldi temp1,17			
	mov temp9,temp1						; PS				
	rcall TWI_MT_DATA_TEMP1
	; len				
	LDS temp1,(adr_TFT_ZEIGER)
	add temp9,temp1						; PS				
	rcall TWI_MT_DATA_TEMP1
	; Intialisierung	
	LDS temp8,(adr_TFT_ZEIGER)			; Schleife			
	ldi ZL,LOW (adr_GRAFIC_PUFFER_256)
	ldi ZH,HIGH(adr_GRAFIC_PUFFER_256)
;-----------------------------------------------------------------------------
TFT_PAKET_SENDEN_D:
	LD temp1,Z+							; DATA				
	add temp9,temp1						; PS				
	rcall TWI_MT_DATA_TEMP1
	dec temp8							; Schleife			
	brne TFT_PAKET_SENDEN_D
	; BCC (PRFSUMME)	
	mov temp1,temp9						; PS				
	rcall TWI_MT_DATA_TEMP1
;	rcall TWI_STOP
;-----------------------------------------------------------------------------
	; ANTWORT			
	rcall TFT_PAKET_ANTWORT_TEMP1
	cpi temp1,6
	breq TFT_PAKET_SENDEN_OK
;-----------------------------------------------------------------------------
	; ERROR				
	rcall BEEP_KURZ
	ROT_ON
	ldi temp,255						; TWBR auf max
	OUT TWBR,temp
	rjmp TFT_PAKET_SENDEN_S				; nochmal senden
;-----------------------------------------------------------------------------
TFT_PAKET_SENDEN_OK:
	STS(adr_TFT_ZEIGER),NULL			; NULL			
	; wieder herstellen	
	pop ZH
	pop ZL
	pop temp9
	pop temp8
;	pop temp7
;	pop temp6
;	pop temp5
;	pop temp4
;	pop temp3
;	pop temp2
	pop temp1
	pop temp
	ret
; #############################################################################
; #############################################################################
; #############################################################################
; Inhalt DISPLAY-SENDEPUFFER anfordern											
; OUT: temp1(ANZAHL BYTES)+SRAM													
;																				
TFT_BUFFER_READ:
	rcall TFT_PAKET_SENDEN  	; PUFFER leeren		
;-----------------------------------------------------------------------------
	; SRAM clear		
	STS(adr_GRAFIC_PUFFER_256+0),NULL
	STS(adr_GRAFIC_PUFFER_256+1),NULL
	STS(adr_GRAFIC_PUFFER_256+2),NULL
	STS(adr_GRAFIC_PUFFER_256+3),NULL
	; START				
	ldi temp1,(TWI_ADR_TFT)
	rcall TWI_MT_START_TEMP1
	; <DC2>				
	ldi temp1,18			
	mov temp9,temp1			; PS
	rcall TWI_MT_DATA_TEMP1
	; len				
	ldi temp1,1
	add temp9,temp1			; PS
	rcall TWI_MT_DATA_TEMP1
	; DATA				
	ldi temp1,'S'
	add temp9,temp1			; PS
	rcall TWI_MT_DATA_TEMP1
	; BCC (PRFSUMME)	
	mov temp1,temp9
	rcall TWI_MT_DATA_TEMP1
;-----------------------------------------------------------------------------
	; ANTWORT			
	rcall TFT_PAKET_ANTWORT_TEMP1
	cpi temp1,6
	breq PAKET_INHALT_SENDEPUFFER_ANFORDERN_OK
;-----------------------------------------------------------------------------
	ROT_ON
	rcall BEEP_KURZ
	rjmp TFT_BUFFER_READ
;-----------------------------------------------------------------------------
PAKET_INHALT_SENDEPUFFER_ANFORDERN_OK:
	ldi temp1,(TWI_ADR_TFT)
	rcall TWI_MR_START_TEMP1
	rcall TWI_MR_DATA_TEMP1	; <DC1>
	rcall TWI_MR_DATA_TEMP1	; <len>
	push temp1
	tst temp1
	breq PAKET_INHALT_SENDEPUFFER_ANFORDERN_ENDE
	; Schleife		
	mov temp9,temp1
	; Z-ZEIGER		
	ldi ZL,LOW (adr_GRAFIC_PUFFER_256)
	ldi ZH,HIGH(adr_GRAFIC_PUFFER_256)
PAKET_INHALT_SENDEPUFFER_ANFORDERN_S:
	rcall TWI_MR_DATA_TEMP1
	; im SRAM ablegen	
	ST Z+,temp1
	dec temp9
	brne PAKET_INHALT_SENDEPUFFER_ANFORDERN_S
;-----------------------------------------------------------------------------
PAKET_INHALT_SENDEPUFFER_ANFORDERN_ENDE:
	rcall TWI_MR_LAST_DATA_TEMP1				; PS
	rcall TWI_STOP
	pop temp1									; Anzahl Bytes	
ret
; #############################################################################
; #############################################################################
; #############################################################################
; Antwortbyte vom DISPLAY anfordern												
;																				
; OUT: temp1																	
;																			 	
TFT_PAKET_ANTWORT_TEMP1:
	; START				
	ldi temp1,(TWI_ADR_TFT)
	rcall TWI_MR_START_TEMP1
	; DATENBYTE abholen	
	rcall TWI_MR_LAST_DATA_TEMP1
	; STOPP				
	rjmp TWI_STOP
; #############################################################################
; #############################################################################
; #############################################################################
; FARBE-SCHRIFT:	<ESC>+"FZ"+FARBE+FARBE										
; FARBE-TEXT:		<ESC>+"FT"+FARBE+FARBE										
; FARBE-GRAFIC:		<ESC>+"FG"+FARBE+FARBE										
FARBE_SCHWARZ:
	ldi temp,(KONST_FARBE_SCHWARZ)
	rjmp FARBE_TEMP
;-------------------------------------------------------------------------------
FARBE_WEISS:
	ldi temp,(KONST_FARBE_WEISS)
	rjmp FARBE_TEMP
;-------------------------------------------------------------------------------
FARBE_GRAU:
	ldi temp,(KONST_FARBE_GRAU)
	rjmp FARBE_TEMP
;-------------------------------------------------------------------------------
FARBE_DUNKEL_GRAU:
	ldi temp,(KONST_FARBE_DUNKEL_GRAU)
	rjmp FARBE_TEMP
;-------------------------------------------------------------------------------
FARBE_ROT:
	ldi temp,(KONST_FARBE_ROT)
	rjmp FARBE_TEMP
;-------------------------------------------------------------------------------
FARBE_GRUEN:
	ldi temp,(KONST_FARBE_GRUEN)
	rjmp FARBE_TEMP
;-------------------------------------------------------------------------------
FARBE_BLAU:
;	ldi temp,(KONST_FARBE_BLAU)
	ldi temp,(KONST_FARBE_HELL_BLAU)
	rjmp FARBE_TEMP
;-------------------------------------------------------------------------------
FARBE_GELB:
	ldi temp,(KONST_FARBE_GELB)
	rjmp FARBE_TEMP
;-------------------------------------------------------------------------------
FARBE_MAGENTA:
	ldi temp,(KONST_FARBE_GELB)
	rjmp FARBE_TEMP
; #############################################################################
FARBE_TEMP:
	push temp						; Kopie-A	
	push temp						; Kopie-B	
	push temp						; Kopie-C	
	; Farbe-TEXT		
	rcall ASCII_ESC_27				; ESC 		
	rcall ASCII_F
	rcall ASCII_T
	pop temp						; Kopie-C	
	rcall TFT_DATA_TEMP				; Farbwert	
	ldi temp,(KONST_FARBE_SCHWARZ)	; Farbwert	
	rcall TFT_DATA_TEMP
	; Farbe-Grafic		
	rcall ASCII_ESC_27				; ESC 		
	rcall ASCII_F
	rcall ASCII_G
	pop temp						; Kopie-B	
	rcall TFT_DATA_TEMP				; Farbwert	
	ldi temp,(KONST_FARBE_SCHWARZ)	; Farbwert	
	rcall TFT_DATA_TEMP
	; Farbe-Schrift		
	rcall ASCII_ESC_27				; ESC 		
	rcall ASCII_F
	rcall ASCII_Z
	pop temp						; Kopie-A	
	rcall TFT_DATA_TEMP				; Farbwert	
	ldi temp,(KONST_FARBE_SCHWARZ)	; Farbwert	
	rjmp TFT_DATA_TEMP
; #############################################################################
; #############################################################################
; #############################################################################
ZEILE_0_CLEAR:
	rcall ZEILE_0
	rcall ASCII_SPACE20
	rcall ASCII_SPACE20
	rcall ZEILE_0
	rjmp TFT_PAKET_SENDEN
; #############################################################################
; #############################################################################
; #############################################################################
ZEILE_0:
	ldi temp2,0
	rjmp ZEILE_TEMP2
;-------------------------------------------------------------------------------
ZEILE_1:
	ldi temp2,1
	rjmp ZEILE_TEMP2
;-------------------------------------------------------------------------------
ZEILE_2:
	ldi temp2,2
	rjmp ZEILE_TEMP2
;-------------------------------------------------------------------------------
ZEILE_3:
	ldi temp2,3
	rjmp ZEILE_TEMP2
;-------------------------------------------------------------------------------
ZEILE_4:
	ldi temp2,4
	rjmp ZEILE_TEMP2
;-------------------------------------------------------------------------------
ZEILE_5:
	ldi temp2,5
	rjmp ZEILE_TEMP2
;-------------------------------------------------------------------------------
ZEILE_6:
	ldi temp2,6
	rjmp ZEILE_TEMP2
;-------------------------------------------------------------------------------
ZEILE_7:
	ldi temp2,7
	rjmp ZEILE_TEMP2
;-------------------------------------------------------------------------------
ZEILE_8:
	ldi temp2,8
	rjmp ZEILE_TEMP2
;-------------------------------------------------------------------------------
ZEILE_9:
	ldi temp2,9
	rjmp ZEILE_TEMP2
;-------------------------------------------------------------------------------
ZEILE_10:	
	ldi temp2,10
	rjmp ZEILE_TEMP2
;-------------------------------------------------------------------------------
ZEILE_11:
	ldi temp2,11
	rjmp ZEILE_TEMP2
;-------------------------------------------------------------------------------
ZEILE_12:
	ldi temp2,12
	rjmp ZEILE_TEMP2
;-------------------------------------------------------------------------------
ZEILE_13:
	ldi temp2,13
	rjmp ZEILE_TEMP2
;-------------------------------------------------------------------------------
ZEILE_14:
	ldi temp2,14
	rjmp ZEILE_TEMP2
;-------------------------------------------------------------------------------
ZEILE_TEMP2:
	ldi temp1,1			; SPALTE	
rjmp KURSOR_POSITION_TEMP1_2	; temp1=Spalte temp2=Zeile	
; #############################################################################
; ##############################################################################
; ##############################################################################
; temp1=SPALTE 000..39															
; temp2=ZEILE	 0...15															
KURSOR_POSITION_TEMP1_2:
	rcall ASCII_ESC_27	; ESC 		
	rcall ASCII_T
	rcall ASCII_P
	mov temp,temp1		; X-SPALTE	
	rcall TFT_DATA_TEMP
	inc temp2
	mov temp,temp2		; Y-ZEILE	
	rjmp TFT_DATA_TEMP
; #############################################################################
; #############################################################################
; #############################################################################
KURSOR_NEXT_ZEILE:
	ldi temp,13
	rcall TFT_DATA_TEMP
	ldi temp,10
	rjmp TFT_DATA_TEMP
;######################################################################## 
;########################################################################
;######################################################################## 
TEXT_Z:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	brne GRAFIC_TEXT_Z_w 	; Sprung
	rcall TFT_PAKET_SENDEN
	ret
GRAFIC_TEXT_Z_w:
	rcall TFT_DATA_TEMP
	rjmp TEXT_Z
; #############################################################################
; #############################################################################
; #############################################################################
; Punktgre / Liniendicke														
PUNKTGROESSE_1:
	ldi temp1,1				; Gre		
	rjmp PUNKTGROESSE_TEMP1
;-------------------------------------------------------------------------------
PUNKTGROESSE_2:
	ldi temp1,2	
	rjmp PUNKTGROESSE_TEMP1
;-------------------------------------------------------------------------------
PUNKTGROESSE_3:
	ldi temp1,3	
	rjmp PUNKTGROESSE_TEMP1
;-------------------------------------------------------------------------------
PUNKTGROESSE_4:
	ldi temp1,4	
	rjmp PUNKTGROESSE_TEMP1
;-------------------------------------------------------------------------------
PUNKTGROESSE_5:
	ldi temp1,5	
	rjmp PUNKTGROESSE_TEMP1
;-------------------------------------------------------------------------------
PUNKTGROESSE_6:
	ldi temp1,6	
	rjmp PUNKTGROESSE_TEMP1
;-------------------------------------------------------------------------------
PUNKTGROESSE_7:
	ldi temp1,7	
	rjmp PUNKTGROESSE_TEMP1
;-------------------------------------------------------------------------------
PUNKTGROESSE_8:
	ldi temp1,8	
	rjmp PUNKTGROESSE_TEMP1
;-------------------------------------------------------------------------------
PUNKTGROESSE_9:
	ldi temp1,9	
	rjmp PUNKTGROESSE_TEMP1
;-------------------------------------------------------------------------------
PUNKTGROESSE_10:
	ldi temp1,10	
	rjmp PUNKTGROESSE_TEMP1
;-------------------------------------------------------------------------------
PUNKTGROESSE_11:
	ldi temp1,11	
	rjmp PUNKTGROESSE_TEMP1
;-------------------------------------------------------------------------------
PUNKTGROESSE_12:
	ldi temp1,12	
	rjmp PUNKTGROESSE_TEMP1
;-------------------------------------------------------------------------------
PUNKTGROESSE_13:
	ldi temp1,13	
	rjmp PUNKTGROESSE_TEMP1
;-------------------------------------------------------------------------------
PUNKTGROESSE_14:
	ldi temp1,14	
	rjmp PUNKTGROESSE_TEMP1
;-------------------------------------------------------------------------------
PUNKTGROESSE_15:
	ldi temp1,15	
	rjmp PUNKTGROESSE_TEMP1
; #############################################################################
PUNKTGROESSE_TEMP1:
	rcall ASCII_ESC_27	; ESC 		
	rcall ASCII_G		; "G"		
	rcall ASCII_Z		; "Z"		
	mov temp,temp1
	rcall TFT_DATA_TEMP	; X			
	mov temp,temp1
	rjmp TFT_DATA_TEMP	; Y			
; #############################################################################
; #############################################################################
; #############################################################################
; 320 x 240																	   
; Ein Punkt an die Koordinaten xx1, yy1 setzen									
PUNKT_X_Y:
	push XL
	push XH
	push YL
	push YH
	push ZL
	push ZH
;-------------------------------------------------------------------------------
	rcall ASCII_ESC_27		; ESC 		
	rcall ASCII_G			; "G"		
	rcall ASCII_P			; "P"		
;-------------------------------------------------------------------------------
	mov temp,XL
	rcall TFT_DATA_TEMP		; X(low)	
	mov temp,XH
	rcall TFT_DATA_TEMP		; X(HIGH)	
;-------------------------------------------------------------------------------
	; TFT-Koordinaten	
	ldi ZL, low (240-1)
	ldi ZH,high (240-1)
	sub ZL,YL
	sbc ZH,YH
	mov YL,ZL
	mov YH,ZH
	mov temp,YL
	rcall TFT_DATA_TEMP		; Y(low)	
	mov temp,YH
	rcall TFT_DATA_TEMP		; Y(HIGH)	
;-------------------------------------------------------------------------------
	pop ZH
	pop ZL
	pop YH
	pop YL
	pop XH
	pop XL
ret
; #############################################################################
; #############################################################################
; #############################################################################
; 320x240																		
GRAFIC_LINIE_TEMP1_8:
	push ZL
	push ZH
;-------------------------------------------------------------------------------
	ldi ZL, low (240-1)	; Y1 auf Diagramm	
	ldi ZH,high (240-1)
	sub ZL,temp3
	sbc ZH,temp4
	mov temp3,ZL
	mov temp4,ZH

	ldi ZL, low (240-1)	; Y2 auf Diagramm	
	ldi ZH,high (240-1)
	sub ZL,temp7
	sbc ZH,temp8
	mov temp7,ZL
	mov temp8,ZH
;-------------------------------------------------------------------------------
	rcall ASCII_ESC_27	; ESC 		
	rcall ASCII_G		; "G"		
	rcall ASCII_D		; "D"		
	mov temp,temp1
	rcall TFT_DATA_TEMP	; X1(low)	
	mov temp,temp2
	rcall TFT_DATA_TEMP	; X1(HIGH)	
	mov temp,temp3
	rcall TFT_DATA_TEMP	; Y1(low)	
	mov temp,temp4
	rcall TFT_DATA_TEMP	; Y1(HIGH)	
	mov temp,temp5
	rcall TFT_DATA_TEMP	; X2(low)	
	mov temp,temp6
	rcall TFT_DATA_TEMP	; x2(HIGH)	
	mov temp,temp7
	rcall TFT_DATA_TEMP	; Y2(low)	
	mov temp,temp8
	rcall TFT_DATA_TEMP	; Y2(HIGH)	
;-------------------------------------------------------------------------------
	pop ZH
	pop ZL
ret
; #############################################################################
; #############################################################################
; #############################################################################
GRAFIC_SCHRIFT_FONT:
	; FONT		
	rcall ASCII_ESC_27	; ESC 		
	rcall ASCII_Z
	rcall ASCII_F
	ldi temp,2
	rcall TFT_DATA_TEMP
	; ZOOM		
	rcall ASCII_ESC_27	; ESC 		
	rcall ASCII_Z
	rcall ASCII_Z
	ldi temp,3
	rcall TFT_DATA_TEMP
	ldi temp,3
	rjmp TFT_DATA_TEMP
; #############################################################################
; #############################################################################
; #############################################################################
GRAFIC_SCHRIFT_POSITIONIEREN:
	rcall ASCII_ESC_27		; ESC 	
	rcall ASCII_Z			; Z		
	rcall ASCII_L			; L		
	rcall ASCII_NULL		; XL	
	rcall ASCII_NULL		; XH	
	rcall ASCII_NULL		; YL	
	rjmp  ASCII_NULL		; YH	
; #############################################################################
; #############################################################################
; #############################################################################



